#ifndef VIEDITVIEW_H
#define VIEDITVIEW_H

#include <QPlainTextEdit>
#include "vi.h"

class ViEngine;

class ViEditView : public QPlainTextEdit
{
	Q_OBJECT

#if 0	//	vi.h Ɉړ
public:
	enum Mode {
		CMD = 0,
		INSERT,
	};
#endif

public:
	ViEditView(QWidget *parent = 0);
	~ViEditView();

public:
	Mode	mode() const { return m_mode; }

public:
#if !USE_EVENT_FILTER
	void	setViEngine(ViEngine *viEngine) { m_viEngine = viEngine; }
#endif
	void	moveCursor(QTextCursor::MoveOperation, int n = 1);

public slots:
	void	setMode(Mode mode);
	void	onCursorPositionChanged();

protected:
#if !USE_EVENT_FILTER
	void	keyPressEvent ( QKeyEvent * event );
#endif

signals:
	void	modeChanged(Mode);

private:
	Mode	m_mode;
#if !USE_EVENT_FILTER
	ViEngine	*m_viEngine;
#endif
};

#endif // VIEDITVIEW_H
